/**
 * Created by Administrator on 2016/9/3.
 */
///*
// 2  * zepto插件：向左滑动删除动效
// 3  * 使用方法：$('.itemWipe').touchWipe({itemDelete: '.item-delete'});
// 4  * 参数：itemDelete  删除按钮的样式名
// 5  */

(function ($) {
    $.fn.touchWipe = function (option) {

        this.is_show = false

        var defaults = {
            itemDelete: '.item-delete', //删除元素
        };
        var opts = $.extend({}, defaults, option); //配置选项

        var delWidth = $(opts.itemDelete).width();
        var initX; //触摸位置
        var moveX; //滑动时的位置
        var X = 0; //移动距离
        var objX = 0; //目标对象位置
        var touchesStart = {}
        var isScrolling, isTouched
        var isMoved = false;
        var self = this
        var moveItem = null
        var touchWipeItem

        $(this).on('touchstart', function (event) {
            //event.preventDefault();
            //event.stopImmediatePropagation()
            delWidth = $(this).find(opts.itemDelete).width()
            //alert(this)
            if(delWidth == 0) return
            isScrolling = undefined
            isTouched = true;
            isMoved = false;
            touchesStart.x = event.type === 'touchstart' ? event.targetTouches[0].pageX : event.pageX;
            touchesStart.y = event.type === 'touchstart' ? event.targetTouches[0].pageY : event.pageY;

            var obj = this;
            moveItem = null
            initX = event.targetTouches[0].pageX;
            objX = (obj.style.WebkitTransform.replace(/translateX\(/g, "").replace(/px\)/g, "")) * 1;
            if (objX == 0) {
                $(this).on('touchmove', function (event) {
                    var pageX = event.type === 'touchmove' ? event.targetTouches[0].pageX : event.pageX;
                    var pageY = event.type === 'touchmove' ? event.targetTouches[0].pageY : event.pageY;
                    if (typeof isScrolling === 'undefined') {
                        isScrolling = !!(isScrolling || Math.abs(pageY - touchesStart.y) > Math.abs(pageX - touchesStart.x));
                    }
                    if (isScrolling) {
                        isTouched = false;
                        return;
                    }
                    isMoved = true;
                    moveItem = this
                    event.preventDefault();
                    var obj = this;
                    moveX = event.targetTouches[0].pageX;
                    X = moveX - initX;
                    if (X >= 0) {
                        obj.style.WebkitTransform = "translateX(" + 0 + "px)";
                    } else if (X < 0) {
                        var l = Math.abs(X);
                        obj.style.WebkitTransform = "translateX(" + -l + "px)";
                        if (l > delWidth) {
                            l = delWidth;
                            obj.style.WebkitTransform = "translateX(" + -l + "px)";
                        }
                    }
                });
            } else if (objX < 0) {
                $(this).on('touchmove', function (event) {
                    var pageX = event.type === 'touchmove' ? event.targetTouches[0].pageX : event.pageX;
                    var pageY = event.type === 'touchmove' ? event.targetTouches[0].pageY : event.pageY;
                    if (typeof isScrolling === 'undefined') {
                        isScrolling = !!(isScrolling || Math.abs(pageY - touchesStart.y) > Math.abs(pageX - touchesStart.x));
                    }
                    if (isScrolling) {
                        isTouched = false;
                        return;
                    }
                    isMoved = true;
                    moveItem = this
                    event.preventDefault();
                    var obj = this;
                    moveX = event.targetTouches[0].pageX;
                    X = moveX - initX;
                    if (X >= 0) {
                        var r = -delWidth + Math.abs(X);
                        obj.style.WebkitTransform = "translateX(" + r + "px)";
                        if (r > 0) {
                            r = 0;
                            obj.style.WebkitTransform = "translateX(" + r + "px)";
                        }
                    } else { //向左滑动
                        obj.style.WebkitTransform = "translateX(" + -delWidth + "px)";
                    }
                });
            }
        })

        $(this).on('touchend', function (event) {
            if (isMoved) {
                event.preventDefault();
                var obj = this;
                objX = (obj.style.WebkitTransform.replace(/translateX\(/g, "").replace(/px\)/g, "")) * 1;
                if (objX > -delWidth / 2) {
                    self.close()
                } else {
                    self.open()
                }
            }
        })

        this.open = function() {
            var obj = moveItem
            if(!obj) return

            this.checkClose()

            obj.style.transition = "all 0.2s";
            obj.style.WebkitTransform = "translateX(" + -delWidth + "px)";
            obj.style.transition = "all 0";
            objX = -delWidth;
            self.is_show = true
            touchWipeItem = obj
        }

        this.close = function(obj) {
            if(!obj) obj = moveItem
            if(!obj) return
            obj.style.transition = "all 0.2s";
            obj.style.WebkitTransform = "translateX(" + 0 + "px)";
            obj.style.transition = "all 0";
            objX = 0;
            self.is_show = false
            touchWipeItem = null
            moveItem = null
        }

        this.checkClose = function() {
            if(!touchWipeItem) return false
            this.close(touchWipeItem)
            return true
        }

        //链式返回
        return this;
    };
})(Zepto);